/**
 * Browshot API
 * Take screenshots of any website in real time
 *
 * OpenAPI spec version: 1.16.0
 * Contact: support@browshot.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api

import io.swagger.client.model.Screenshot
import io.swagger.client.model.ScreenshotError
import io.swagger.client.model.ScreenshotHost
import io.swagger.client.model.ScreenshotInfoError
import io.swagger.client.model.ScreenshotList
import io.swagger.client.model.ScreenshotShort
import io.swagger.client.ApiInvoker
import io.swagger.client.ApiException

import com.sun.jersey.multipart.FormDataMultiPart
import com.sun.jersey.multipart.file.FileDataBodyPart

import javax.ws.rs.core.MediaType

import java.io.File
import java.util.Date

import scala.collection.mutable.HashMap

class ScreenshotApi(val defBasePath: String = "https://api.browshot.com/api/v1",
                        defApiInvoker: ApiInvoker = ApiInvoker) {
  var basePath = defBasePath
  var apiInvoker = defApiInvoker

  def addHeader(key: String, value: String) = apiInvoker.defaultHeaders += key -> value 

  /**
   * Request a screenshot
   * Screenshots requests to private and shared instances require a positive balance.  *IMPORTANT*: Remember that you can only do 100 free screenshots per month. To used a premium instance, use instance_id&#x3D;65 for example. 
   * @param url URL of the page to get a screenshot for 
   * @param instanceId instance ID to use 
   * @param size screenshot size - \&quot;screen\&quot; (default) or \&quot;page\&quot; (optional, default to screen)
   * @param cache use a previous screenshot (same URL, same instance) if it was done within &lt;cache_value&gt; seconds. The default value is 24hours. Specify cache&#x3D;0 if you want a new screenshot. (optional, default to 86400)
   * @param delay number of seconds to wait after the page has loaded. This is used to let JavaScript run longer before taking the screenshot. Use delay&#x3D;0 to take screenshots faster. (optional, default to 5)
   * @param flashDelay number of seconds to wait after the page has loaded if Flash elements are present. Use flash_delay&#x3D;0 to take screenshots faster. (optional, default to 10)
   * @param screenWidth width of the browser window. For desktop browsers only. (optional, default to 1024)
   * @param screenHeight height of the browser window. For desktop browsers only. (Note: full-page screenshots can have a height of up to 15,000px) (optional, default to 768)
   * @param priority assign priority to the screenshot (for private instances only) (optional)
   * @param referer use a custom referrer header - paid screenshots only (optional)
   * @param postData send a POST requests with post_data, useful for filling out forms - paid screenshots only (optional)
   * @param cookie set a cookie for the URL requested (see Custom POST Data, Referer and Cookie) Cookies should be separated by a ; - paid screenshots only (optional)
   * @param script URL of javascript file to execute after the page load event (optional)
   * @param details level of information available with screenshot/info (optional, default to 2)
   * @param html saves the HTML of the rendered page which can be retrieved by the API call screenshot/html. This feature costs *1 credit* per screenshot. (optional, default to 0)
   * @param maxWait maximum number of seconds to wait before triggering the PageLoad event. Note that delay will still be used. (default: 0 &#x3D; disabled) (optional, default to 0)
   * @param headers any custom HTTP headers. (Not supported with Internet Explorer) (optional)
   * @param shots take multiple screenshots of the same page. This costs 1 additional credit for every 2 additional screenshots. (optional, default to 1)
   * @param shotInterval number of seconds between 2 screenshots (optional, default to 5)
   * @param hosting hosting option - s3 or browshot (optional)
   * @param hostingHeight maximum height of the thumbnail to host (optional)
   * @param hostingWidth maximum height of the thumbnail to host (optional)
   * @param hostingScale scale of the thumbnail to host (optional, default to 1)
   * @param hostingBucket S3 bucket to upload the screenshot or thumbnail (required for S3) (optional)
   * @param hostingFile file name to use (for S3 only) (optional)
   * @param hostingHeaders list of headers to add to the S3 object (for S3 only) (optional)
   * @return Screenshot
   */
  def screenshotCreateGet(url: String, instanceId: Integer, size: Option[String] /* = screen*/, cache: Option[Integer] /* = 86400*/, delay: Option[Integer] /* = 5*/, flashDelay: Option[Integer] /* = 10*/, screenWidth: Option[Integer] /* = 1024*/, screenHeight: Option[Integer] /* = 768*/, priority: Option[Integer] = None, referer: Option[String] = None, postData: Option[String] = None, cookie: Option[String] = None, script: Option[String] = None, details: Option[Integer] /* = 2*/, html: Option[Integer] /* = 0*/, maxWait: Option[Integer] /* = 0*/, headers: Option[String] = None, shots: Option[Integer] /* = 1*/, shotInterval: Option[Integer] /* = 5*/, hosting: Option[String] = None, hostingHeight: Option[Integer] = None, hostingWidth: Option[Integer] = None, hostingScale: Option[Float] /* = 1*/, hostingBucket: Option[String] = None, hostingFile: Option[String] = None, hostingHeaders: Option[String] = None): Option[Screenshot] = {
    // create path and map variables
    val path = "/screenshot/create".replaceAll("\\{format\\}", "json")

    val contentTypes = List("application/json")
    val contentType = contentTypes(0)

    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if (url == null) throw new Exception("Missing required parameter 'url' when calling ScreenshotApi->screenshotCreateGet")

    queryParams += "url" -> url.toString
    queryParams += "instance_id" -> instanceId.toString
    size.map(paramVal => queryParams += "size" -> paramVal.toString)
    cache.map(paramVal => queryParams += "cache" -> paramVal.toString)
    delay.map(paramVal => queryParams += "delay" -> paramVal.toString)
    flashDelay.map(paramVal => queryParams += "flash_delay" -> paramVal.toString)
    screenWidth.map(paramVal => queryParams += "screen_width" -> paramVal.toString)
    screenHeight.map(paramVal => queryParams += "screen_height" -> paramVal.toString)
    priority.map(paramVal => queryParams += "priority" -> paramVal.toString)
    referer.map(paramVal => queryParams += "referer" -> paramVal.toString)
    postData.map(paramVal => queryParams += "post_data" -> paramVal.toString)
    cookie.map(paramVal => queryParams += "cookie" -> paramVal.toString)
    script.map(paramVal => queryParams += "script" -> paramVal.toString)
    details.map(paramVal => queryParams += "details" -> paramVal.toString)
    html.map(paramVal => queryParams += "html" -> paramVal.toString)
    maxWait.map(paramVal => queryParams += "max_wait" -> paramVal.toString)
    headers.map(paramVal => queryParams += "headers" -> paramVal.toString)
    shots.map(paramVal => queryParams += "shots" -> paramVal.toString)
    shotInterval.map(paramVal => queryParams += "shot_interval" -> paramVal.toString)
    hosting.map(paramVal => queryParams += "hosting" -> paramVal.toString)
    hostingHeight.map(paramVal => queryParams += "hosting_height" -> paramVal.toString)
    hostingWidth.map(paramVal => queryParams += "hosting_width" -> paramVal.toString)
    hostingScale.map(paramVal => queryParams += "hosting_scale" -> paramVal.toString)
    hostingBucket.map(paramVal => queryParams += "hosting_bucket" -> paramVal.toString)
    hostingFile.map(paramVal => queryParams += "hosting_file" -> paramVal.toString)
    hostingHeaders.map(paramVal => queryParams += "hosting_headers" -> paramVal.toString)
    

    var postBody: AnyRef = null

    if (contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart
      postBody = mp
    } else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(apiInvoker.deserialize(s, "", classOf[Screenshot]).asInstanceOf[Screenshot])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Delete screenshot data
   * You can delete details of your screenshots to remove any confidential information. 
   * @param id screenshot ID 
   * @param data data to remove. You can specify multiple of them (separated by a ,): *image* (image files), *url* (url requested), *metadata* (time added, time finished, post data, cookie and referer used for the screenshot), *all* (all data and files)  (optional, default to image)
   * @return List[ScreenshotShort]
   */
  def screenshotDeleteGet(id: Integer, data: Option[String] /* = image*/): Option[List[ScreenshotShort]] = {
    // create path and map variables
    val path = "/screenshot/delete".replaceAll("\\{format\\}", "json")

    val contentTypes = List("application/json")
    val contentType = contentTypes(0)

    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    queryParams += "id" -> id.toString
    data.map(paramVal => queryParams += "data" -> paramVal.toString)
    

    var postBody: AnyRef = null

    if (contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart
      postBody = mp
    } else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(apiInvoker.deserialize(s, "array", classOf[ScreenshotShort]).asInstanceOf[List[ScreenshotShort]])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Host thumbnails on your own S3 account or on Browshot.
   * You can host screenshots and thumbnails on your own S3 account or on Browshot.
   * @param id screenshot ID 
   * @param hosting hosting option: s3 or browshot 
   * @param width width of the thumbnail (optional)
   * @param height height of the thumbnail (optional)
   * @param scale scale of the thumbnail (optional, default to 1)
   * @param bucket S3 bucket to upload the screenshot or thumbnail - required with hosting&#x3D;s3 (optional)
   * @param file file name to use - optional, used with hosting&#x3D;s3 (optional)
   * @param headers HTTP headers to add to your S3 object - optional, used with hosting&#x3D;s3 (optional)
   * @return List[ScreenshotHost]
   */
  def screenshotHostGet(id: Integer, hosting: String, width: Option[Integer] = None, height: Option[Integer] = None, scale: Option[Double] /* = 1*/, bucket: Option[String] = None, file: Option[String] = None, headers: Option[String] = None): Option[List[ScreenshotHost]] = {
    // create path and map variables
    val path = "/screenshot/host".replaceAll("\\{format\\}", "json")

    val contentTypes = List("application/json")
    val contentType = contentTypes(0)

    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if (hosting == null) throw new Exception("Missing required parameter 'hosting' when calling ScreenshotApi->screenshotHostGet")

    queryParams += "id" -> id.toString
    queryParams += "hosting" -> hosting.toString
    width.map(paramVal => queryParams += "width" -> paramVal.toString)
    height.map(paramVal => queryParams += "height" -> paramVal.toString)
    scale.map(paramVal => queryParams += "scale" -> paramVal.toString)
    bucket.map(paramVal => queryParams += "bucket" -> paramVal.toString)
    file.map(paramVal => queryParams += "file" -> paramVal.toString)
    headers.map(paramVal => queryParams += "headers" -> paramVal.toString)
    

    var postBody: AnyRef = null

    if (contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart
      postBody = mp
    } else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(apiInvoker.deserialize(s, "array", classOf[ScreenshotHost]).asInstanceOf[List[ScreenshotHost]])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Get the HTML code
   * Retrieve the HTML code of the rendered page. This API call should be used when html&#x3D;1 was specified in the screenshot request. 
   * @param id screenshot ID 
   * @return void
   */
  def screenshotHtmlGet(id: Integer) = {
    // create path and map variables
    val path = "/screenshot/html".replaceAll("\\{format\\}", "json")

    val contentTypes = List("application/json")
    val contentType = contentTypes(0)

    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    queryParams += "id" -> id.toString
    

    var postBody: AnyRef = null

    if (contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart
      postBody = mp
    } else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
                  case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Query screenshot status
   * Once a screenshot has been requested, its status must be checked until it is either \&quot;error\&quot; or \&quot;finished\&quot;.
   * @param id screenshot ID received from /api/v1/screenshot/create 
   * @param details level of details about the screenshot and the page (optional, default to 2)
   * @return List[Screenshot]
   */
  def screenshotInfoGet(id: Integer, details: Option[Integer] /* = 2*/): Option[List[Screenshot]] = {
    // create path and map variables
    val path = "/screenshot/info".replaceAll("\\{format\\}", "json")

    val contentTypes = List("application/json")
    val contentType = contentTypes(0)

    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    queryParams += "id" -> id.toString
    details.map(paramVal => queryParams += "details" -> paramVal.toString)
    

    var postBody: AnyRef = null

    if (contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart
      postBody = mp
    } else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(apiInvoker.deserialize(s, "array", classOf[Screenshot]).asInstanceOf[List[Screenshot]])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Get information about the last 100 screenshots requested.
   * Get information about the last 100 screenshots requested.
   * @param limit maximum number of screenshots&#39; information to return (optional, default to 100)
   * @param status get list of screenshot in a given status (error, finished, in_process) (optional)
   * @return List[ScreenshotList]
   */
  def screenshotListGet(limit: Option[Integer] /* = 100*/, status: Option[String] = None): Option[List[ScreenshotList]] = {
    // create path and map variables
    val path = "/screenshot/list".replaceAll("\\{format\\}", "json")

    val contentTypes = List("application/json")
    val contentType = contentTypes(0)

    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    limit.map(paramVal => queryParams += "limit" -> paramVal.toString)
    status.map(paramVal => queryParams += "status" -> paramVal.toString)
    

    var postBody: AnyRef = null

    if (contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart
      postBody = mp
    } else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(apiInvoker.deserialize(s, "array", classOf[ScreenshotList]).asInstanceOf[List[ScreenshotList]])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Request multiple screenshots
   * Request multiple screenshots in one API call. The API call accepts all the parameters supported by screenshot/create. You can specify up to 10 URLs and 10 instances for a total of 100 screenshots in one API call. 
   * @param url URL of the page to get a screenshot for. You can specify multiple url parameters (up to 10). 
   * @param instanceId instance ID to use. You can specify multiple instance_id parameters (up to 10). 
   * @param size screenshot size - \&quot;screen\&quot; (default) or \&quot;page\&quot; (optional, default to screen)
   * @param cache use a previous screenshot (same URL, same instance) if it was done within &lt;cache_value&gt; seconds. The default value is 24hours. Specify cache&#x3D;0 if you want a new screenshot. (optional, default to 86400)
   * @param delay number of seconds to wait after the page has loaded. This is used to let JavaScript run longer before taking the screenshot. Use delay&#x3D;0 to take screenshots faster. (optional, default to 5)
   * @param flashDelay number of seconds to wait after the page has loaded if Flash elements are present. Use flash_delay&#x3D;0 to take screenshots faster. (optional, default to 10)
   * @param screenWidth width of the browser window. For desktop browsers only. (optional, default to 1024)
   * @param screenHeight height of the browser window. For desktop browsers only. (Note: full-page screenshots can have a height of up to 15,000px) (optional, default to 768)
   * @param priority assign priority to the screenshot (for private instances only) (optional)
   * @param referer use a custom referrer header - paid screenshots only (optional)
   * @param postData send a POST requests with post_data, useful for filling out forms - paid screenshots only (optional)
   * @param cookie set a cookie for the URL requested (see Custom POST Data, Referer and Cookie) Cookies should be separated by a ; - paid screenshots only (optional)
   * @param script URL of javascript file to execute after the page load event (optional)
   * @param details level of information available with screenshot/info (optional, default to 2)
   * @param html saves the HTML of the rendered page which can be retrieved by the API call screenshot/html. This feature costs *1 credit* per screenshot. (optional, default to 0)
   * @param maxWait maximum number of seconds to wait before triggering the PageLoad event. Note that delay will still be used. (default: 0 &#x3D; disabled) (optional, default to 0)
   * @param headers any custom HTTP headers. (Not supported with Internet Explorer) (optional)
   * @param hosting hosting option - s3 or browshot (optional)
   * @param hostingHeight maximum height of the thumbnail to host (optional)
   * @param hostingWidth maximum height of the thumbnail to host (optional)
   * @param hostingScale scale of the thumbnail to host (optional, default to 1)
   * @param hostingBucket S3 bucket to upload the screenshot or thumbnail (required for S3) (optional)
   * @param hostingFile file name to use (for S3 only) (optional)
   * @param hostingHeaders list of headers to add to the S3 object (for S3 only) (optional)
   * @return ScreenshotList
   */
  def screenshotMultipleGet(url: String, instanceId: Integer, size: Option[String] /* = screen*/, cache: Option[Integer] /* = 86400*/, delay: Option[Integer] /* = 5*/, flashDelay: Option[Integer] /* = 10*/, screenWidth: Option[Integer] /* = 1024*/, screenHeight: Option[Integer] /* = 768*/, priority: Option[Integer] = None, referer: Option[String] = None, postData: Option[String] = None, cookie: Option[String] = None, script: Option[String] = None, details: Option[Integer] /* = 2*/, html: Option[Integer] /* = 0*/, maxWait: Option[Integer] /* = 0*/, headers: Option[String] = None, hosting: Option[String] = None, hostingHeight: Option[Integer] = None, hostingWidth: Option[Integer] = None, hostingScale: Option[Float] /* = 1*/, hostingBucket: Option[String] = None, hostingFile: Option[String] = None, hostingHeaders: Option[String] = None): Option[ScreenshotList] = {
    // create path and map variables
    val path = "/screenshot/multiple".replaceAll("\\{format\\}", "json")

    val contentTypes = List("application/json")
    val contentType = contentTypes(0)

    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if (url == null) throw new Exception("Missing required parameter 'url' when calling ScreenshotApi->screenshotMultipleGet")

    queryParams += "url" -> url.toString
    queryParams += "instance_id" -> instanceId.toString
    size.map(paramVal => queryParams += "size" -> paramVal.toString)
    cache.map(paramVal => queryParams += "cache" -> paramVal.toString)
    delay.map(paramVal => queryParams += "delay" -> paramVal.toString)
    flashDelay.map(paramVal => queryParams += "flash_delay" -> paramVal.toString)
    screenWidth.map(paramVal => queryParams += "screen_width" -> paramVal.toString)
    screenHeight.map(paramVal => queryParams += "screen_height" -> paramVal.toString)
    priority.map(paramVal => queryParams += "priority" -> paramVal.toString)
    referer.map(paramVal => queryParams += "referer" -> paramVal.toString)
    postData.map(paramVal => queryParams += "post_data" -> paramVal.toString)
    cookie.map(paramVal => queryParams += "cookie" -> paramVal.toString)
    script.map(paramVal => queryParams += "script" -> paramVal.toString)
    details.map(paramVal => queryParams += "details" -> paramVal.toString)
    html.map(paramVal => queryParams += "html" -> paramVal.toString)
    maxWait.map(paramVal => queryParams += "max_wait" -> paramVal.toString)
    headers.map(paramVal => queryParams += "headers" -> paramVal.toString)
    hosting.map(paramVal => queryParams += "hosting" -> paramVal.toString)
    hostingHeight.map(paramVal => queryParams += "hosting_height" -> paramVal.toString)
    hostingWidth.map(paramVal => queryParams += "hosting_width" -> paramVal.toString)
    hostingScale.map(paramVal => queryParams += "hosting_scale" -> paramVal.toString)
    hostingBucket.map(paramVal => queryParams += "hosting_bucket" -> paramVal.toString)
    hostingFile.map(paramVal => queryParams += "hosting_file" -> paramVal.toString)
    hostingHeaders.map(paramVal => queryParams += "hosting_headers" -> paramVal.toString)
    

    var postBody: AnyRef = null

    if (contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart
      postBody = mp
    } else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(apiInvoker.deserialize(s, "", classOf[ScreenshotList]).asInstanceOf[ScreenshotList])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Search for screenshots of a specific URL.
   * Search for screenshots of a specific URL.
   * @param url look for a string matching the URL requested 
   * @param limit maximum number of screenshots&#39; information to return (optional, default to 50)
   * @param status get list of screenshot in a given status (error, finished, in_process) (optional)
   * @return List[ScreenshotList]
   */
  def screenshotSearchGet(url: String, limit: Option[Integer] /* = 50*/, status: Option[String] = None): Option[List[ScreenshotList]] = {
    // create path and map variables
    val path = "/screenshot/search".replaceAll("\\{format\\}", "json")

    val contentTypes = List("application/json")
    val contentType = contentTypes(0)

    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if (url == null) throw new Exception("Missing required parameter 'url' when calling ScreenshotApi->screenshotSearchGet")

    queryParams += "url" -> url.toString
    limit.map(paramVal => queryParams += "limit" -> paramVal.toString)
    status.map(paramVal => queryParams += "status" -> paramVal.toString)
    

    var postBody: AnyRef = null

    if (contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart
      postBody = mp
    } else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(apiInvoker.deserialize(s, "array", classOf[ScreenshotList]).asInstanceOf[List[ScreenshotList]])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Share a screenshot
   * You can make your screenshots public, add notes, and share it with your friends and colleagues. Only screenshots which are successfully completed can be shared.n the thumbnail. You can take a 1024x768 screenshot, crop it to 768x768, and get it scaled down to 300x300. 
   * @param id screenshot ID 
   * @param note note to add on the sharing page (optional)
   * @return List[ScreenshotHost]
   */
  def screenshotShareGet(id: Integer, note: Option[String] = None): Option[List[ScreenshotHost]] = {
    // create path and map variables
    val path = "/screenshot/share".replaceAll("\\{format\\}", "json")

    val contentTypes = List("application/json")
    val contentType = contentTypes(0)

    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    queryParams += "id" -> id.toString
    note.map(paramVal => queryParams += "note" -> paramVal.toString)
    

    var postBody: AnyRef = null

    if (contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart
      postBody = mp
    } else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(apiInvoker.deserialize(s, "array", classOf[ScreenshotHost]).asInstanceOf[List[ScreenshotHost]])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Retrieve a thumbnail image
   * Unlike the other API calls, this API sends back the thumbnail as a PNG file, not JSON. The HTTP response code indicates whether the screenshot was successful (200), or incomplete (404) or failed (404). If the screenshot failed or is not finished, a default image \&quot;Not found\&quot; is sent.  You can crop your screenshots. The crop is done first, then the thumbnail. You can take a 1024x768 screenshot, crop it to 768x768, and get it scaled down to 300x300. 
   * @param id screenshot ID 
   * @param width width of the thumbnail (optional)
   * @param height height of the thumbnail (optional)
   * @param scale scale of the thumbnail (optional, default to 1)
   * @param zoom zoom 1 to 100 percent (optional, default to 100)
   * @param ratio Use fit to keep the original page ration, and fill to get a thumbnail for the exact width and height.  specified. If you provide both width and height, you need to specify the ratio: fit to keep the original width/height ratio (the thumbnail might be smaller than the specified width and height), or fill to crop the image if necessary. (optional, default to fit)
   * @param left left edge of the area to be cropped (optional, default to 0)
   * @param right right edge of the area to be cropped (optional, default to 0)
   * @param top top edge of the area to be cropped (optional, default to 0)
   * @param bottom bottom edge of the area to be cropped (optional)
   * @param format image as PNG or JPEG (optional, default to png)
   * @param shot get the second or third screenshot if multiple screenshots were requested (optional, default to 1)
   * @param quality JPEG quality factor (for JPEG thumbnails only) (optional, default to 100)
   * @return void
   */
  def screenshotThumbnailGet(id: Integer, width: Option[Integer] = None, height: Option[Integer] = None, scale: Option[Double] /* = 1*/, zoom: Option[Integer] /* = 100*/, ratio: Option[String] /* = fit*/, left: Option[Integer] /* = 0*/, right: Option[Integer] /* = 0*/, top: Option[Integer] /* = 0*/, bottom: Option[Integer] = None, format: Option[String] /* = png*/, shot: Option[Integer] /* = 1*/, quality: Option[Integer] /* = 100*/) = {
    // create path and map variables
    val path = "/screenshot/thumbnail".replaceAll("\\{format\\}", "json")

    val contentTypes = List("application/json")
    val contentType = contentTypes(0)

    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    queryParams += "id" -> id.toString
    width.map(paramVal => queryParams += "width" -> paramVal.toString)
    height.map(paramVal => queryParams += "height" -> paramVal.toString)
    scale.map(paramVal => queryParams += "scale" -> paramVal.toString)
    zoom.map(paramVal => queryParams += "zoom" -> paramVal.toString)
    ratio.map(paramVal => queryParams += "ratio" -> paramVal.toString)
    left.map(paramVal => queryParams += "left" -> paramVal.toString)
    right.map(paramVal => queryParams += "right" -> paramVal.toString)
    top.map(paramVal => queryParams += "top" -> paramVal.toString)
    bottom.map(paramVal => queryParams += "bottom" -> paramVal.toString)
    format.map(paramVal => queryParams += "format" -> paramVal.toString)
    shot.map(paramVal => queryParams += "shot" -> paramVal.toString)
    quality.map(paramVal => queryParams += "quality" -> paramVal.toString)
    

    var postBody: AnyRef = null

    if (contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart
      postBody = mp
    } else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
                  case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

}
